import { Component, OnInit } from "@angular/core";
import { IgxIconService } from "igniteui-angular";

import { faCoffee, IconLookup } from '@fortawesome/free-solid-svg-icons';
import { FaIconLibrary } from "@fortawesome/angular-fontawesome";

interface MenuItem {
    name: string;
    iconDefault: IconLookup;
    iconSelected: IconLookup;
    active: boolean;
}

@Component({
    selector: "app-svg-icon-sample",
    styleUrls: ["./svg-icon-sample.component.scss"],
    templateUrl: "./svg-icon-sample.component.html"
})
export class SvgIconSampleComponent implements OnInit {

    constructor(public iconService: IgxIconService,
                public faIconLibrary: FaIconLibrary) { }


    public svgTemplate = '<svg id="icon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 {{x}} {{y}}"><path d="{{path}}" /></svg>'

    public coffee: MenuItem = {
        name: 'Home',
        iconDefault: { prefix: 'far', iconName: 'coffee' },
        iconSelected: { prefix: 'fas', iconName: 'coffee' },
        active: true 
    };

    public menuItems = [ this.coffee ];

    public ngOnInit() {
        this.faIconLibrary.addIcons(faCoffee);
        this.iconService.addSvgIconFromText(
            faCoffee.iconName,
            this.svgTemplate
                .replace('{{path}}', faCoffee.icon[4] as string)
                .replace('{{x}}', String(faCoffee.icon[0]))
                .replace('{{y}}', String(faCoffee.icon[1])), faCoffee.prefix);
    }
}
